#include <gtk/gtk.h>
#include <gtask/gtask.h>
#include <gtask-ui/gtask-ui.h>

#include <stdio.h>

glong num_iters = 1;

GTaskGenericTask *download_1;
GTaskGenericTask *download_2;
GTaskGenericTask *mult_files;

GTaskFile        *file1;

/* runs every 1/2 second */
gboolean
run_examples( gpointer null ) {
    gchar *tmp;

    /* Download 1 is a 14M file that will take 40 seconds to download */
    if( num_iters < 82 ) {
        tmp = g_strdup_printf( "%0.2fM of 14M", 14 * ((float)num_iters/81.0) );

        gtask_generic_task_set_status_message( download_1, tmp );
        gtask_generic_task_set_percent_done( download_1, (float) num_iters / 81.0 );
        gtask_generic_task_set_time_left( download_1, (81 - num_iters) / 2 );

        g_free( tmp );

        gtask_generic_task_serialize( download_1 );
    }

    /* Download 2 is a 28K file that will take 10 seconds to download */
    if( num_iters < 22 ) {
        tmp = g_strdup_printf( "%0.1fK of 28K", 28.0 * ((float)num_iters/21.0) );

        gtask_generic_task_set_status_message( download_2, tmp );
        gtask_generic_task_set_percent_done( download_2, (float) num_iters / 21.0 );
        gtask_generic_task_set_time_left( download_2, (21 - num_iters) / 2 );

        g_free( tmp );

        gtask_generic_task_serialize( download_2 );
    }

    if( num_iters < 51 ) {
        gtask_generic_task_set_percent_done( mult_files, (float) num_iters / 50.0 );

        gtask_generic_task_set_time_left( download_2, (50 - num_iters) / 2 );

        if( num_iters == 24 )
            gtask_file_set_completed( file1, TRUE );

        gtask_generic_task_serialize( mult_files );
    }

    /*
    if( num_iters > 50 ) {
        g_object_unref( download_1 );
        g_object_unref( download_2 );
        g_object_unref( cd_ripping );

        //exit( 0 );
    }
    */

    /*
    gtask_generic_task_serialize( cd_ripping );
    */

    num_iters++;
}

void do_nothing(){ }

int main( int argc, char **argv ) {
    GTaskGenericTask *task;
    GTaskFile        *file;

    gtk_init( &argc, &argv );

    gnome_vfs_init();

    gtk_init( &argc, &argv );

    g_log_set_handler( NULL, G_LOG_LEVEL_WARNING | G_LOG_LEVEL_DEBUG,
                       do_nothing, NULL );

    g_log_set_handler( "GTask", G_LOG_LEVEL_WARNING | G_LOG_LEVEL_DEBUG,
                       do_nothing, NULL );

    g_log_set_handler( "GTask-UI", G_LOG_LEVEL_WARNING | G_LOG_LEVEL_DEBUG,
                       do_nothing, NULL );

    gtask_ui_init( &argc, &argv, GTASK_ROLE_PROVIDER );

    /* Sample Download 1 */
    download_1 = gtask_factory_create_task( NULL, "GTaskDownloadTask" );

    file = gtask_file_new_with_properties( SRCDIR"/data/codemonkey.mpg",
                                           "video/mpeg",
                                           "",
                                           "Code Monkey!" );

    gtask_generic_task_add_file( download_1, file );

    gtask_generic_task_set_title( download_1, "codemonkey.mpg" );
    gtask_generic_task_set_percent_done( download_1, 0.0 );

    /* Sample Download 2 */
    download_2 = gtask_factory_create_task( NULL, "GTaskDownloadTask" );

    file = gtask_file_new_with_properties( SRCDIR"/data/vase.jpg",
                                           "image/jpeg",
                                           "",
                                           "" );
    gtask_file_set_completed( file, FALSE );
    gtask_generic_task_add_file( download_2, file );
    gtask_generic_task_set_title( download_2, "vase.jpg" );
    gtask_generic_task_set_percent_done( download_2, 0.0 );

    /* Sample Task with Multiple Files */
    mult_files = gtask_factory_create_task( NULL, "GTaskDownloadTask" );
    gtask_generic_task_set_percent_done( mult_files, 0.0 );

    gtask_generic_task_set_title( mult_files, "This task creates 2 files" );
    gtask_generic_task_set_status_message( mult_files, "insert informative message here" );
    file = gtask_file_new_with_properties( SRCDIR"/data/penguins.jpg",
                                            "image/jpeg",
                                            "",
                                            "" );

    gtask_generic_task_add_file( mult_files, file );
    file1 = file;

    file = gtask_file_new_with_properties( SRCDIR"/data/beach_chair.jpg",
                                            "image/jpeg",
                                            "",
                                            "" );

    gtask_generic_task_add_file( mult_files, file );
    g_timeout_add( 500, run_examples, NULL);

    gtk_main( );
    /*
     * just show off some of the main windows, etc
     * in the future we will showcase the different task types, etc.
     */
    return 0;
}
