/* gTask
 * Copyright (C) 2004 Michael Henson                                       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GTASK_CELL_RENDERER_BASIC_H
#define GTASK_CELL_RENDERER_BASIC_H

#include <gtk/gtkcellrenderer.h>

#include <gtask/gtask-generic-task.h>

/** @addtogroup GTaskCellRendererBasic */

/* @{ */

typedef struct _GTaskCellRendererBasic        GTaskCellRendererBasic;
typedef struct _GTaskCellRendererBasicClass   GTaskCellRendererBasicClass;
typedef struct _GTaskCellRendererBasicPrivate GTaskCellRendererBasicPrivate;

/** returns the GType of GTaskCellRendererBasic */
#define GTASK_CELL_RENDERER_BASIC_TYPE    (gtask_cell_renderer_basic_get_type())

/** casts the passed in object to a GTaskCellRendererBasic */
#define GTASK_CELL_RENDERER_BASIC(obj)    (G_TYPE_CHECK_INSTANCE_CAST( (obj), \
                                           GTASK_CELL_RENDERER_BASIC_TYPE, \
                                           GTaskCellRendererBasic ))

/** casts the passed in object to a GTaskCellRendererBasicClass */
#define GTASK_CELL_RENDERER_BASIC_CLASS(klass) \
                                          (G_TYPE_CHECK_CLASS_CAST( (klass), \
                                           GTASK_CELL_RENDERER_BASIC_TYPE, \
                                           GTaskCellRendererBasicClass ))

/**
 * returns TRUE if the passed in object is a GTaskCellRenderer
 * FALSE otherwise
 */
#define GTASK_IS_CELL_RENDERER_BASIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE( (obj), \
                                           GTASK_CELL_RENDERER_BASIC_TYPE ))

/**
 * returns TRUE if the passed in object is a GTaskCellRendererBasicClass
 * FALSE otherwise
 */
#define GTASK_IS_CELL_RENDERER_BASIC_CLASS(klass) \
                                          (G_TYPE_CHECK_CLASS_TYPE( (klass), \
                                           GTASK_CELL_RENDERER_BASIC_TYPE ))

#define GTASK_CELL_RENDERER_BASIC_GET_CLASS(obj) \
                                          (G_TYPE_INSTANCE_GET_CLASS( (obj), \
                                           GTASK_CELL_RENDERER_BASIC_TYPE, \
                                           GTaskCellRendererBasicClass ))


struct _GTaskCellRendererBasic {
	GtkCellRenderer                parent;
	GTaskCellRendererBasicPrivate *private;
};

struct _GTaskCellRendererBasicPrivate {
    gfloat              progress;
    glong               time_left;
    char               *title;
    char               *status_msg;
    GTaskActivityState  activity_state;

    GdkPixbuf          *preview;
    gboolean            preview_is_thumb;
    GdkPixbuf          *thumbnail_frame;
};

struct _GTaskCellRendererBasicClass {
	GtkCellRendererClass parent;
};

GtkType gtask_cell_renderer_basic_get_type( void );

GtkCellRenderer *
gtask_cell_renderer_basic_new( void );

/* @} */

#endif
