/* gTask
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Copyright (C) 2002 Naba Kumar <kh_naba@users.sourceforge.net>
 * heavily modified by Jrgen Scheibengruber <mfcn@gmx.de>
 * borrowed from gnome-system-monitor and modified yet some more
 */
#ifndef GTASK_CELL_RENDERER_PROGRESS_H
#define GTASK_CELL_RENDERER_PROGRESS_H

#include <gtk/gtkcellrenderer.h>

#include <gtask/gtask-generic-task.h>

/** @addtogroup GTaskCellRendererProgress */

/* @{ */

typedef struct _GTaskCellRendererProgress        GTaskCellRendererProgress;
typedef struct _GTaskCellRendererProgressClass   GTaskCellRendererProgressClass;
typedef struct _GTaskCellRendererProgressPrivate GTaskCellRendererProgressPrivate;

/** returns the GType of GTaskCellRendererProgress */
#define GTASK_CELL_RENDERER_PROGRESS_TYPE \
                                       (gtask_cell_renderer_progress_get_type())

/** casts the passed in object to a GTaskCellRendererProgress */
#define GTASK_CELL_RENDERER_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST( (obj), \
                                           GTASK_CELL_RENDERER_PROGRESS_TYPE, \
                                           GTaskCellRendererProgress ))

/** casts the passed in object to a GTaskCellRendererProgressClass */
#define GTASK_CELL_RENDERER_PROGRESS_CLASS(klass) \
                                          (G_TYPE_CHECK_CLASS_CAST( (klass), \
                                           GTASK_CELL_RENDERER_PROGRESS_TYPE, \
                                           GTaskCellRendererProgressClass ))

/**
 * returns TRUE if the passed in object is a GTaskCellRenderer
 * FALSE otherwise
 */
#define GTASK_IS_CELL_RENDERER_PROGRESS(obj) \
                                        (G_TYPE_CHECK_INSTANCE_TYPE( (obj), \
                                         GTASK_CELL_RENDERER_PROGRESS_TYPE ))

/**
 * returns TRUE if the passed in object is a GTaskCellRendererProgressClass
 * FALSE otherwise
 */
#define GTASK_IS_CELL_RENDERER_PROGRESS_CLASS(klass) \
                                        (G_TYPE_CHECK_CLASS_TYPE( (klass), \
                                         GTASK_CELL_RENDERER_PROGRESS_TYPE ))

#define GTASK_CELL_RENDERER_PROGRESS_GET_CLASS(obj) \
                                        (G_TYPE_INSTANCE_GET_CLASS( (obj), \
                                         GTASK_CELL_RENDERER_PROGRESS_TYPE, \
                                         GTaskCellRendererProgressClass ))


struct _GTaskCellRendererProgress {
	GtkCellRenderer                   parent;
	GTaskCellRendererProgressPrivate *private;
};

struct _GTaskCellRendererProgressPrivate {
    gfloat             value;
    GTaskActivityState activity_state;
};

struct _GTaskCellRendererProgressClass {
	GtkCellRendererClass parent;
};

GtkType gtask_cell_renderer_progress_get_type( void );

GtkCellRenderer *
gtask_cell_renderer_progress_new( void );

/* @} */

#endif
