/* gTask
 * Copyright (C) 2004 Michael Henson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GTASK_UI_UTIL_H
#define GTASK_UI_UTIL_H

#include <glib.h>
#include <gnome.h>
#include <gtask/gtask-generic-task.h>
#include <gtask/gtask-file.h>

typedef struct _GTaskPreview      GTaskPreview;
typedef struct _GTaskFileListInfo GTaskFileListInfo;

struct _GTaskPreview {
    gchar     *uri;
    gboolean   is_thumbnail;
};

struct _GTaskFileListInfo {
    guint  num_files;
    guint  num_completed_files;

    guint  num_unique_directories;

    GList *files;
    GList *unique_directories;
};

GTaskFileListInfo *
gtask_ui_get_file_list_info( GList *file_list );

void
gtask_ui_file_list_info_free( GTaskFileListInfo *info );

GSList *
gtask_ui_get_task_preview_options( GTaskGenericTask *task );

GSList *
gtask_ui_get_file_preview_options( GTaskFile *file );

GTaskPreview *
gtask_preview_new( gchar *uri, gboolean is_thumbnail );

void
gtask_preview_free( GTaskPreview *preview );

void
gtask_preview_list_free( GSList *list );

GdkPixbuf *
gtask_preview_get_pixbuf( GTaskPreview *preview,
                          GnomeThumbnailFactory *factory );

void
gtask_ui_draw_progressbar( GtkWidget *widget,
                           GdkWindow *window,
                           GdkRectangle *area,
                           float progress,
                           GTaskActivityState state,
                           int x,
                           int y,
                           int width,
                           int height );


#endif
