#include <unistd.h>

#include <gtask-ui/gtask-ui.h>

#include <gtask/gtask.h>

static GTaskUIManager *ui_manager = NULL;

void
gtask_ui_init( int *argc, char ***argv, GTaskRole role ) {
    GTaskConnectionGroup *conn_group;
    GTaskConnection      *conn;
    GTaskEventDispatcher *dispatcher;

    if( ui_manager != NULL )
        return;

    gtask_init( argc, argv, role );

    /* set up the loop back connection, any data written to the
     * input fd on this connection, comes right back out
     * the output fd. This connection is mainly used to facilitate
     * the ui-fallback features of the library
     */
    conn = gtask_connection_new_with_properties( "loopback", role );

    conn_group = gtask_factory_get_connection_group( NULL );

    /** @todo need some way of talling a GTaskConnection to
     *        try to autoreconnect or not to */
    gtask_connection_connect_loopback( conn );

    dispatcher = gtask_connection_get_event_dispatcher( conn );

    ui_manager = gtask_ui_manager_new( );

    gtask_event_dispatcher_add_watch( dispatcher,
                                      GTASK_TASK_PACKET_TYPE,
                                      gtask_ui_manager_private_task_event,
                                      ui_manager );

    gtask_connection_group_add_connection( conn_group, conn );

    g_object_unref( (GObject *) conn );
}
